<?

	// Dynamo Library 2011-04-25
	//
	// PHP data editing and reporting library
	//
	// A set of PHP functions that allow easy viewing of multi-part queries,
	// and editing of PHP tables or queries.
	//
	// You must connect to the database server and select the DB
	// before using these functions.
	//
	// $dbLink = mysql_connect($host, $user, $pass);
	// mysql_select_db($base);


	// Splits an ouput query and executes it
	function DynamoOutputQuery($query) {

		// Escape semicolons
		str_replace('\;', '[semicolon]', $query);

		// Split the query
		$queryArray = explode(';', $query);

		// Loop through the queries
		for ($i=0; $i<count($queryArray); $i++) {
			if ($queryArray[$i] != '') {

				// Replace the semicolon's
				str_replace('[semicolon]', ';', $query);

				// Execute the query
				$retVal .= DynamoRawQuery($queryArray[$i]);
			};
		};

		// Return the result
		return $retVal;

	};


	// Executes a query and returns the results in an array
	function DynamoVarQuery($query) {

		// Execute the query
		$dbResult = mysql_query($query);

		// Display the error
		if (!$dbResult) {
		   die('Dynamo Error, Invalid Query: ' . mysql_error());
		}

		// Make sure there is only one row
		if (mysql_num_rows($dbResult) > 1) {
			die('Dynamo Error:  Too many rows returned.');
		};

		// Fetch the row
		$row = mysql_fetch_row($dbResult);

		// Loop through all the fields
		$fieldCount = mysql_num_fields($dbResult);
		for($j=0; $j<$fieldCount; $j++) {
			$retVal[mysql_field_name($dbResult, $j)] = $row[$j];
		};

		// Return the array
		return $retVal;

	};


	// Executes a query and returns the results as an html table
	function DynamoTableQuery($query, $class = 'dynamo', $header = false) {

		// Execute the query
		$dbResult = mysql_query($query);

		// Display the error
		if (!$dbResult) {
		   die('Dynamo Error, Invalid Query: ' . mysql_error());
		};

		// Make sure there is at least one row
		if (mysql_num_rows($dbResult) < 1) {
			return false;
			exit;
		};

		// Start the table
		$retVal = "<table class=\"$class\">\n";

		// Draw the header
		if ($header = true) {

			// Start the header row
			$retVal .= "  <tr class=\"$class\">\n";

			// Loop through the fields
			for($i=0;$i<mysql_num_fields($dbResult);$i++) {

				// Get the field name
				$field = mysql_field_name($dbResult, $i);

				// Start the column
				$retVal .= "    <td class=\"$class\">";

				// Set the value
				$retVal .= "<strong class=\"$class\">$field</strong>";

				// End the column
				$retVal .= "</td>\n";

			};

			// End the header row
			$retVal .= "  </tr>\n";

		};

		// Loop through all the rows
		$rowCount = @mysql_num_rows($dbResult);
		for ($i=0; $i<$rowCount; $i++) {

			// Start the row
			$retVal .= "  <tr class=\"$class\">\n";

			// Fetch the row
			$row = mysql_fetch_row($dbResult);

			// Loop through all the fields
			$fieldCount = mysql_num_fields($dbResult);
			for($j=0; $j<$fieldCount; $j++) {

				// Start the column
				$retVal .= "    <td class=\"$class\">";

				// Set the value
				$retVal .= $row[$j];

				// End the column
				$retVal .= "</td>\n";

			};

			// End the row
			$retVal .= "  </tr>\n";

		};

		// End the table
		$retVal .= "</table>\n";

		return $retVal;

	};


	// Executes a query and returns the results as an html table
	function DynamoVertTableQuery($query, $class = 'dynamo') {

		// Execute the query
		$dbResult = mysql_query($query);

		// Display the error
		if (!$dbResult) {
		   die('Dynamo Error: Invalid Query: ' . mysql_error());
		};

		// Make sure there is only one row
		if (mysql_num_rows($dbResult) > 1) {
			die('Dynamo Error:  Too many rows returned.');
		};

		// Fetch the row
		$row = mysql_fetch_row($dbResult);

		// Start the table
		$retVal = "<table class=\"$class\">\n";

		// Loop through all the fields
		$fieldCount = mysql_num_fields($dbResult);
		for($j=0; $j<$fieldCount; $j++) {

			// Start the row
			$retVal .= "  <tr class=\"$class\">\n";

			// Start the column
			$retVal .= "    <td class=\"$class\">" . mysql_field_name($dbResult, $j) . "</td>\n";

			// Set the value
			$retVal .= "    <td class=\"$class\">" . $row[$j] . "</td>\n";

			// End the column
			$retVal .= "  </tr>\n";

		};

		// End the row
		$retVal .= "  </tr>\n";

		// End the table
		$retVal .= "</table>\n";

		return $retVal;

	};


	// Executes a query and returns the results as a multiple column html table
	function DynamoColTableQuery($query, $columns) {

		// Execute the query
		$dbResult = mysql_query($query);

		// Display the error
		if (!$dbResult) {
		   die('Dynamo Error, Invalid Query: ' . mysql_error());
		};

		// Verify a single column was returned
		$fieldCount = mysql_num_fields($dbResult);
		if ($fieldCount != 1) {
			die('Dynamo Error: More than one column returned.');
		};

		// Start the table
		$retVal = "<table>\n";

		// Loop through all the rows
		$rowCount = @mysql_num_rows($dbResult);
		for ($i=0; $i<$rowCount/$columns; $i++) {

			// Start the row
			$retVal .= "  <tr>\n";

			// Make $columns columns
			for ($c=0; $c<$columns; $c++) {

				// Fetch the row
				$row = mysql_fetch_row($dbResult);

				// Fix blank values
				if ($row[0] == '') {
					$row[0] = '&nbsp;';
				};

				// Set the row
				$retVal .= "    <td>$row[0]</td>\n";


			};

			// End the row
			$retVal .= "  </tr>\n";

		};

		// End the table
		$retVal .= "</table>\n";

		// Return the value
		return $retVal;

	};


	// Executes a query and returns the results as CSV (comma separated) text
	function DynamoCsvQuery($query, $header = false, $separator = ',') {

		// Initialize the variables
		$retVal = '';

		// Execute the query
		$dbResult = mysql_query($query);

		// Display the error
		if (!$dbResult) {
		   die('Dynamo Error, Invalid Query: ' . mysql_error());
		};

		// Make sure there is at least one row
		if (mysql_num_rows($dbResult) < 1) {
			return false;
			exit;
		};

		// Draw the header
		if ($header = true) {

			// Loop through the fields
			for($i=0;$i<mysql_num_fields($dbResult);$i++) {

				// Get the field name
				$field = mysql_field_name($dbResult, $i);

				// Set the value
				$retVal .= '"' . str_replace('"', '""', $field) . '"';

				// Add the seperator, if this isn't the last field
				if ($i < mysql_num_fields($dbResult)-1) {
					$retVal .= $separator;
				}

			};

			// End the header row
			$retVal .= "\n";

		};

		// Loop through all the rows
		$rowCount = @mysql_num_rows($dbResult);
		for ($i=0; $i<$rowCount; $i++) {

			// Fetch the row
			$row = mysql_fetch_row($dbResult);

			// Loop through all the fields
			$fieldCount = mysql_num_fields($dbResult);
			for($j=0; $j<$fieldCount; $j++) {

				// Set the value
				$retVal .= '"' . str_replace('"', '""', $row[$j]) . '"';

				// If it's not the last, end the column
				if ($j < $fieldCount-1) {
					$retVal .= $separator;
				}

			};

			// End the row
			$retVal .= "\n";

		};

		return $retVal;

	};	
	

	// Executes a query and return the unformatted results
	function DynamoRawQuery($query) {

		// Globals
		global $queryVal;

		// Execute the query
		$dbResult = mysql_query($query);

		// Display the error
		if (!$dbResult) {
		   die('Dynamo Error, Invalid Query: ' . mysql_error());
		}

		// Loop through all the rows
		$rowCount = @mysql_num_rows($dbResult);
		for ($i=0; $i<$rowCount; $i++) {

			$row = mysql_fetch_row($dbResult);

			// Loop through all the fields
			$fieldCount = mysql_num_fields($dbResult);
			for($j=0; $j<$fieldCount; $j++) {
				$retVal .= $row[$j];
			};

		};

		// Return the result
		return $retVal;

	};


	// Create an edit form based on a query and return the html code
	function DynamoEditForm($query, $page, $class = 'dynamo') {

		// Fix the query
		$query = stripslashes($query);

		// Execute the query
		$dbResult = mysql_query($query);

		// Display the error
		if (!$dbResult) {
		   die('Dynamo Error, Invalid Query: ' . mysql_error());
		}

		// Make sure there is only one row
		if (mysql_num_rows($dbResult) > 1) {
			die('Dynamo Error:  Too many rows returned.');
		};

		// Start a form
		$retVal = "<form action=\"$page\" method=\"POST\">\n";
		$retVal .= "<input class=\"$class\" type=\"hidden\" name=\"id\" value=\"" . mysql_insert_id() . "\">\n";

		// Start a table
		$retVal .= "<table class=\"$class\">\n";

		// Display the fields
		$fieldCount = mysql_num_fields($dbResult);
		for ($i=0; $i<$fieldCount; $i++) {

			// Start the table row
			$retVal .= "<tr class=\"$class\">\n";

			// Show the field name
			$retVal .= "<td class=\"$class\">\n";
			$retVal .= mysql_field_name($dbResult, $i); // . ' (' . mysql_field_type($dbResult, $i) . '): ';
			$retVal .= "</td>\n";

			// Strip the field name
			$stripName = preg_replace('/\W/', '', mysql_field_name($dbResult, $i));

			// Show the input
			$retVal .= "<td class=\"$class\">\n";
			switch (mysql_field_type($dbResult, $i)) {
				case 'blob':
					$retVal .= "<textarea class=\"$class\" name=\"" . $stripName . "\" rows=\"10\" cols=\"60\">" . mysql_result($dbResult, 0, $i) . "</textarea>\n";
					break;
				default:
					$retVal .= "<input class=\"$class\" type=\"text\" name=\"" . $stripName . "\" value=\"" . mysql_result($dbResult, 0, $i) . "\" size=\"40\">\n";
					break;
			};
			$retVal .= "</td>\n";

			// End the table row
			$retVal .= "</tr>\n";

		};

		// Draw the submit button
		$retVal .= "<tr class=\"$class\"><td class=\"$class\" colspan=\"2\"><br><center><input type=\"submit\" value=\"Submit Changes\"></center></td></tr>\n";

		// End the table
		$retVal .= "</table>\n";

		// End the form
		$retVal .= "</form>\n";

		// Return the result
		return $retVal;

	};


?>
